#第一题
#思路是依次将数据放到数据栈里面和运算符放到运算符栈里面，然后判断数据前和数据后的运算符优先级，
# 如果数据前运算符优先级高，便可计算该数据之前的表达式的值，否则需要继续录入数据


from pythonds.basic.stack import Stack
#定义运算函数
def doMath(op,op1,op2):
    if op =='*':
        return op1*op2
    elif op == '/':
        return op1/op2
    elif op =='+':
        return op1+op2
    else:
        return op1-op2
#定义最后执行转化并计算的函数
def infixToPostfix(infixexpr):
    #确定优先级
    prec={}
    prec["*"]=3
    prec["/"]=3
    prec["+"]=2
    prec["-"]=2
    prec["("]=1
    #确定数字栈和运算符栈
    opStack=Stack()
    numStack=Stack()
    #把字符串分割成一个个字符
    tokenList=infixexpr.split()
    for token in tokenList:
        #如果是数字或字母，就放到数字栈等待运算
        if token in "ABCDEFGHIGKLMNOPQRSTUVWXYZ" or token in "0123456789":
            numStack.push(int(token))
        #左括号直接放进运算符栈
        elif token=='(':
            opStack.push(token)
        #遇到右括号，先把左括号到右括号中间的部分算出来
        elif token==')':
            #左右括号之间的算式就是一个小的运算式，所以运算规则和下方没有括号时相同
            while (opStack.peek() != '('):
                operand2=numStack.pop()
                operand1=numStack.pop()
                result=doMath(opStack.pop(),operand1,operand2)
                numStack.push(result)
            #最后要删除运算符栈里的左括号，不然会出错
            opStack.pop()
        #既不是数字，也不是括号，即是运算符时
        else:
            #当运算符栈不空并且当前的运算符优先级低于或等于前一个运算符时，就可以把这个运算符前面的两个数字
            #根据它们夹的运算符而计算出来
            while (not opStack.isEmpty()) and (prec[opStack.peek()]>=prec[token]):
                #取数字栈里的顶部两个数字，也就是该运算符前面的两个数字
                operand2=numStack.pop()
                operand1=numStack.pop()
                #根据他们中间的运算符算出两个数运算的结果，并且将他们之间的运算符从运算符栈删去
                result=doMath(opStack.pop(),operand1,operand2)
                numStack.push(result)
            #把当前运算符放进运算符栈里
            opStack.push(token)
    #当经过上述操作把能算的都算出后，只需要按照数字和运算符依次两两算出结果即可
    # 最后剩下的一个数就是我们想要的结果
    while not opStack.isEmpty():
        operand2=numStack.pop()
        operand1=numStack.pop()
        result=doMath(opStack.pop(),operand1,operand2)
        numStack.push(result)
    #返回并删除它，运算符栈和数字栈全是空的了，perfect！
    return numStack.pop()



from pythonds.basic.queue import Queue
def sort(list):
    main=Queue()
    #创建key为0，1，2...的字典，每个数字对应一个空队列
    dic={i:Queue() for i in range(10)}
    l=len(str(list[0]))
    #把列表里的数字放到main队列里&为了找到长度最长的数字位数从而终止循环
    for m in list:
        main.enqueue(m)
        if(len(str(m))>l):
            l=len(str(m))
    list=[]#把list清空方便最后把main中的数字放回list
    #循环l次，分别排好个位十位知道最高位
    for j in range(l):
        #将指定位的数字对应放进对应的队列
        while not main.isEmpty():
            num=main.dequeue()
            k=(num//(10**j))%10
            dic[k].enqueue(num)
        #将所有数字按照从小到大放回main队列
        for a in range(10):
            while not dic[a].isEmpty():
                main.enqueue(dic[a].dequeue())
    #把main队列里的数字放回列表
    while not main.isEmpty():
        list.append(main.dequeue())
    return list


#第三题
from pythonds.basic.stack import Stack
def Checker(String):
    #创建两个栈，一个储存所有的<tag>,另一个每储存一个/tag就与s栈最后的tag匹配
    #匹配成功将该tag从s中清除，否则不匹配，结束
    s=Stack()
    alis=Stack()
    #是否匹配的flag
    flag=True
    index=0
    #将输入的内容转化成为规则的字符串，方便循环和检查
    lis=String.split()
    nlis=''.join(lis)
    #当始终匹配，一直循环到末尾
    while index<len(nlis) and flag:
        symbol=nlis[index]
        if symbol=='<':
            #如果是<tag>型，就把<tag>放进s栈里
            if nlis[index+1]!='/':
                while symbol!='>':
                    s.push(symbol)
                    index=index+1
                    symbol=nlis[index]
                s.push(symbol)
            #否则就是</tag>型，直接跳过/，把tag放进a栈里
            else:
                index=index+2
                symbol=nlis[index]
                while symbol!='>':
                    alis.push(symbol)
                    index=index+1
                    symbol=nlis[index]
                #去掉>
                s.pop()
                #判断tag栈中<>中间的tag是否与刚检测到的</tag>的tag一致，逐位检验，如果不一致，返回false并退出
                symbol=s.pop()
                while symbol!='<':
                    if alis.isEmpty():
                        flag=False
                        break
                    else:
                        if symbol!=alis.pop():
                            flag=False
                            break
                    symbol=s.pop()
                if not alis.isEmpty():
                    flag=False
        #检验完一个，继续循环
        index=index+1

    if flag and s.isEmpty():
        return True
    else:
        return False



#第四题击鼓传花，假设传n次，依次输出n次的人的姓名
from pythonds.basic.queue import Queue
import random
#定义函数，需要引入姓名列表以及传递的次数n
def hotPotato(namelist,n):
    simqueue=Queue()
    j=0
    #把姓名放到队列里
    for name in namelist:
        simqueue.enqueue(name)
    #循环n次
    while j<n:
        #每次循环产生一个随机数，该随机数代表每次传递数
        for i in range(random.randrange(5)):
            #假设传花从队首开始，每传一次，就把队首的人放到队尾，这样循环i次，则此时的队首就是拿花的人
            simqueue.enqueue(simqueue.dequeue())
        #输出队首人的姓名，但不删除，进行下一次传花
        a=simqueue.dequeue()
        print(a)
        simqueue.enqueue(a)
        #j记录已经输出的人的数量
        j=j+1

