#将中缀表达式转换为后缀同时求值
from pythonds.basic.stack import Stack

def infixToPostfix(infixexpr):  #传入数字运算符以空格间隔的字符串形式表达式
    prec = {}
    prec['*'] = 3
    prec['/'] = 3
    prec['+'] = 2
    prec['-'] = 2
    prec['('] = 1
    opStack = Stack()       #存储操作符的栈
    nuStack = Stack()       #存储数字和计算结果的栈
    tokenList = infixexpr.split()
    def op(a,b,c):
        if b == '+':
            return a+c
        elif b == '*':
            return a*c
        elif b == '-':
            return c-a
        elif b == '/':
            return c/a

    for token in tokenList:
        if token in '+-*/':
            while (not opStack.isEmpty()) and (prec[opStack.peek()] >= prec[token]):
                #将栈顶的两个数字做运算并删除，将结果压入栈：
                nuStack.push(op(int(nuStack.pop()), opStack.pop(), int(nuStack.pop())))
            opStack.push(token)
        elif token == '(':
            opStack.push(token)
        elif token == ')':
            topToken = opStack.pop()
            while topToken != '(':
                nuStack.push(op(int(nuStack.pop()), topToken, int(nuStack.pop())))
                topToken = opStack.pop()
        else:
            nuStack.push(token)
    while not opStack.isEmpty():
        nuStack.push(op(int(nuStack.pop()), opStack.pop(), int(nuStack.pop())))
        
    return nuStack.items[0]    #返回整数形式的运算结果    
