# -*- coding: utf-8 -*-
from pythonds.basic.stack import Stack

def infixEval(infixExpr):
    prec = {}
    prec['^'] = 4
    prec['*'] = 3
    prec['/'] = 3
    prec['+'] = 2
    prec['-'] = 2
    prec['('] = 1
    opStack = Stack()
    operandStack = Stack()
    tokenlist = infixExpr.split()
    for token in tokenlist:
        if token in '0123456789':
            operandStack.push(int(token))
        elif token == '(':
            opStack.push(token)
        elif token == ')':
            topToken = opStack.pop()
            while topToken != '(':
                doMath(operandStack,topToken)
                topToken = opStack.pop()
        else:
            while (not opStack.isEmpty()) and \
                (prec[opStack.peek()] >= prec[token]):
                    doMath(operandStack,opStack.pop())
            opStack.push(token)
    while not opStack.isEmpty():
        doMath(operandStack,opStack.pop())
    return operandStack.pop()

def doMath(aStack,op):
    op2 = aStack.pop()
    op1 = aStack.pop()
    if op == '*':
        result = op1 * op2
    elif op == '/':
        result = op1 / op2
    elif op == '+':
        result = op1 + op2
    elif op == '-':
        result = op1 - op2
    else:
        result = op1 ** op2
    aStack.push(result)


