# 陈一潇
# 1400017639


from pythonds.basic.stack import Stack
from pythonds.basic.queue import Queue


def bsort(lst):
    """基数排序算法，把输入的一个自然数（包括0）列表按照从小到大排序。"""
    for item in lst:
        assert isinstance(item, int) and item >= 0 # 检查是否是自然数的列表

    # 初始化
    main = Queue()
    num_dict = {i: Queue() for i in range(10)}
    main.items = lst
    max_len = max((len(str(i)) for i in lst))
    total = len(lst)

    # 核心算法
    for i in range(max_len):
        for j in range(total):
            num = main.dequeue()
            try:
                num_dict[int(str(num)[-i-1])].enqueue(num)  # 按照某位的大小进入不同的队列
            except:
                num_dict[0].enqueue(num)  # 首位自动补零，借用了异常处理机制实现，为了省事儿不写判断了
        for k in range(9, -1, -1):
            while not num_dict[k].isEmpty():
                main.enqueue(num_dict[k].dequeue())  # 把各个子队列合并回来

    return main.items

if __name__ == '__main__':  # 也提供了一个测试接口，空格分隔输入正整数列，输入小数会自动取整
    while True:
        try:
            lst = [int(i) for i in input("input list of number, sep with space -> ").split()]
            print(bsort(lst))
        except Exception as e:
            print(e)
