# 陈一潇
# 1400017639


from pythonds.basic.stack import Stack
from pythonds.basic.queue import Queue


def tag_checker(filename):
    """读取一个文件，返回其中的tag是否匹配，可以处理tag为空或者内容包含<>的情况"""

    # 初始化
    with open(filename) as file:
        content = file.read()
    tag_stack = Stack()
    temp_lst = []
    temp_checker = 0

    # 逐个读取字符来找tag，这里的算法可以完整提取出一个tag的内容，即使tag为空或者包含<>也不会出错
    # temp_lst用于临时存放tag中的字符方便之后拼合
    # temp_checker是记录"<"的数目，只有随后的">"数目匹配时才算读取了一个完整的tag
    for char in content:
        if char == "<":
            temp_checker += 1
            temp_lst.append(char)

        elif char == ">":
            temp_checker -= 1
            temp_lst.append(char)

            if temp_checker < 0:
                temp_checker = 0
                continue  # 单独的>会被忽略
            if temp_checker == 0:  # 括号成对，生成tag
                tag = "".join(temp_lst)
                temp_lst = []
                if tag[1] != "/":
                    tag_stack.push(tag)  # 如果不是闭tag，则入栈
                else:  # 否则检查是否匹配
                    if tag_stack.peek()[1:len(tag)-2] == tag[2:-1]:
                        tag_stack.pop()
                    else:
                        return False

        elif temp_checker > 0:
            temp_lst.append(char)

    # 最后栈空则匹配成功
    return tag_stack.isEmpty()

if __name__ == '__main__':  # 也提供了一个测试接口，输入文件目录，输入1.html是对作业ppt中的那个样例做测试，但由于是最基础的版本，难以实际应用。
    file = input("input html file -> ")
    print(tag_checker(file))
