# 陈一潇
# 1400017639


from pythonds.basic.stack import Stack
from pythonds.basic.queue import Queue
from random import randrange


def hit_drum_pass_flower(people, max_pass, play_time, print_result=True):
    """击鼓传花，people传入一个人名单，max_pass为每次最大传的次数，play_time为总共传出多少个人，
    如果print_result为真，将会在每次传出一个人时显示传的次数和他的名字，最后返回一个包含由次数和人名组成的元组的列表"""

    # 初始化
    sim_queue = Queue()
    for person in people:
        sim_queue.enqueue(person)
    result_lst = []

    # 击鼓传花，总次数给定
    for i in range(play_time):
        pass_num = randrange(1, max_pass+1)
        for j in range(pass_num-1):
            sim_queue.enqueue(sim_queue.dequeue())
        lucky_dog = sim_queue.dequeue()
        result_lst.append((pass_num, lucky_dog))
        sim_queue.enqueue(lucky_dog)

        if print_result:
            print("After pass {} times, {} was picked!".format(pass_num, lucky_dog))

    return result_lst

if __name__ == '__main__':  # 依然有个测试接口，因为手动输入人名太麻烦了，这里设置成默认人名了，可以手动修改。
    people = ["Bill", "David", "Susan", "Jane", "Kent", "Brad"]
    hit_drum_pass_flower(people, 7, 5)
